
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import javax.swing.*;
import javax.swing.event.*;


public class BNWrap extends JApplet
{
    boolean isStandalone = false;
	private DrawArea da;
	private JTextField fldIn;
	private JTextField fldOut;
    private Container cp;
    private ButtonGroup bg;
    private JRadioButton rb1;
    private JRadioButton rb2;
    private JRadioButton rb3;

    //Get a parameter value
    public String getParameter(String key, String def)
    {
        return isStandalone ? System.getProperty(key, def) :
            (getParameter(key) != null ? getParameter(key) : def);
    }

    //Construct the applet
    public BNWrap()
    {
    }

    //Initialize the applet
    public void init()
    {
        rb1 = new JRadioButton( "Final Settings" );
        rb1.setActionCommand("2");
        rb2 = new JRadioButton( "Iteration" );
        rb2.setActionCommand("0");
        rb3 = new JRadioButton( "Loop" );
        rb3.setActionCommand("1");

        bg = new ButtonGroup();
        bg.add( rb1 );
        bg.add( rb2 );
        bg.add( rb3 );

		Box bh = Box.createHorizontalBox();
		Box bh1 = Box.createHorizontalBox();
		Box bv = Box.createVerticalBox();
		Box bv1 = Box.createVerticalBox();

    	da = new DrawArea();
//	    fldIn = new JTextField( "01234567" );
	    fldOut = new JTextField( "01234567" );


        JButton btn = new JButton( " Next Iteration " );
        JButton btnset = new JButton( " Set " );

        da.setPermutationIn( "01234567" );
        da.setPermutationOut( "01234567" );
        da.setInerationNumber( -1 );
        da.setInerationType(4);

        btnset.addActionListener(
            new ActionListener()
            {
                public void actionPerformed(ActionEvent e)
                {
                    da.nextIneration();
                    da.setPermutationOut( fldOut.getText() );
                    if( da.isError() ) JOptionPane.showMessageDialog( cp, "Error setting output values." );
                    cp.repaint();
                }
            } );

        btn.addActionListener(
            new ActionListener()
            {
                public void actionPerformed(ActionEvent e)
                {
                    da.nextIneration();
//                    da.setPermutationOut( fldOut.getText() );
                    cp.repaint();
                }
            } );


        fldOut.addActionListener(
            new ActionListener()
            {
                public void actionPerformed(ActionEvent e)
                {
//                    da.setPermutationIn( fldIn.getText() );
                    da.setInerationNumber( 0 );
//                    da.setInerationType(0);
                    da.setPermutationOut( fldOut.getText() );
                    cp.repaint();
                }
            } );

            ActionListener al =
                new ActionListener()
                {
                    public void actionPerformed(ActionEvent e)
                    {
                        da.setInerationNumber( 1 );
                        da.setInerationType( Integer.parseInt(e.getActionCommand()) );
                        cp.repaint();
                    }
                };
        rb1.addActionListener( al );
        rb2.addActionListener( al );
        rb3.addActionListener( al );

		DrawArea da = new DrawArea();

        cp = this.getContentPane();

        cp.add( da, BorderLayout.CENTER );

        bh.add( bh.createHorizontalStrut( 10 ) );


		bh1.add( new JLabel("Out: ") );
		bh1.add( fldOut );
        bh1.add( bh1.createHorizontalStrut( 5 ) );
		bh1.add( btnset );
        bv1.add( bh1 );
        bv1.add( bv1.createVerticalStrut( 25 ) );
		bv1.add( btn );

        bh.add( bv1 );
        bh.add( bh.createHorizontalStrut( 10 ) );
        bv.add( rb1 );
        bv.add( rb2 );
        bv.add( rb3 );
        bh.add( bv );

        cp.add( bh,BorderLayout.SOUTH );
    }

    //Start the applet
    public void start()
    {
    }

    //Stop the applet
    public void stop()
    {
    }

    //Destroy the applet
    public void destroy()
    {
    }

    //Get Applet information
    public String getAppletInfo()
    {
        return "Benes Network Simulation";
    }

    //Get parameter info
    public String[][] getParameterInfo()
    {
        return null;
    }

    //Main method
    public static void main(String[] args)
    {
        BNWrap applet = new BNWrap();
        applet.isStandalone = true;
        Frame frame;
        frame = new Frame() {
            protected void processWindowEvent(WindowEvent e) {
                super.processWindowEvent(e);
                if (e.getID() == WindowEvent.WINDOW_CLOSING) {
                    System.exit(0);
                }
            }
            public synchronized void setTitle(String title) {
                super.setTitle(title);
                enableEvents(AWTEvent.WINDOW_EVENT_MASK);
            }
        };
        frame.setTitle("Applet Frame");
        frame.add(applet, BorderLayout.CENTER);
        applet.init();
        applet.start();
        frame.setSize(600,620);
        Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
        frame.setLocation((d.width - frame.getSize().width) / 2, (d.height - frame.getSize().height) / 2);
        frame.setVisible(true);
    }
}