

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.math.*;
import BenesNetwork.*;

public class DrawArea extends JPanel
{
    private BenesNetwork bn ;

	private static int[] in = new int[8];
	private static int[] pre = new int[8];
    private static int nit=0;
    private static int iType=0;
    private static boolean err=false;

    public DrawArea()
	{
//        this.setPermutation( "12345670" );
    }

    public boolean isError()
    {
        return err;
    }

    public void setInerationNumber( int it )
    {
        this.nit = it;
    }

    public void setInerationType( int iType )
    {
        this.iType = iType;
    }

    public void nextIneration()
    {
        this.nit++;
    }

    public void setPermutationIn( String s )
    {
        int i;

        char[] cs = new char[9];
        s.getChars(0,7,cs,0);

        for( i=0; i < 8; i++ )
            in[i] = 0;


        for( i=0; i < s.length() && i < 8; i++ )
        {
            in[i] = Integer.parseInt(s.substring(i,i+1));
        }
    }

    public void setPermutationOut( String s )
    {
        int i;
        err = false;
        char[] cs = new char[9];
        s.getChars(0,7,cs,0);

        for( i=0; i < 8; i++ )
            pre[i] = 0;

        if( s.length() != 8 ) err = true;
        for( i=0; i < s.length() && i < 8; i++ )
        {
            pre[i] = Integer.parseInt(s.substring(i,i+1));
        }

        int c=0;
        for( int j = 0; j < 8; j++ )
        {
            for( i = 0; i < 8; i++ )
            {
                if( pre[i] == j ) { c++; break; }
            }
        }
        if( c !=8 )
        {
            err = true;
            pre[0] = 0;
            pre[1] = 1;
            pre[2] = 2;
            pre[3] = 3;
            pre[4] = 4;
            pre[5] = 5;
            pre[6] = 6;
            pre[7] = 7;

        }
    }

	public void paintComponent( Graphics g )
	{
		super.paintComponent( g );
//		this.setBounds(0,0,600,320);

	    bn = new BenesNetwork( 4, 5 );

		int[] out = new int[8];

		for( int ip = 0; ip < 8; ip++ )
		{
			out[pre[ip]] = in[ip];
		}

		bn.execute(in,out,0,0,5,4, nit, iType );

		Switch[][] sw = bn.getNetwork();

		for( int i = 0; i < 5; i++ )
		{
			for( int j = 0; j < 4; j++ )
			{
				g.setColor( Color.blue );
				drawSwitch(g, sw[j][i], i, j );
				g.setColor( Color.blue );
				if( i != 4 )
					drawConnect(g, sw, i, j );
			}
		}
        drawNumbers(g);
	}

	public void drawNumbers( Graphics g )
    {
        char[] s = new char[2];
        s[1] = 0;
	   	g.setColor( Color.black );

        for( int i=0; i < 4; i++ )
        {
            s[0] = String.valueOf(in[i*2]).charAt(0);
            g.drawChars( s, 0, 1, 15-6-6, i*60+30+5 );
            s[0] = String.valueOf(in[i*2+1]).charAt(0);
            g.drawChars( s, 0, 1, 15-6-6, i*60+30+35 );

            s[0] = String.valueOf(in[i*2]).charAt(0);
            g.drawChars( s, 0, 1, 4*60+30+15+6, i*60+30+5 );
            s[0] = String.valueOf(in[i*2+1]).charAt(0);
            g.drawChars( s, 0, 1, 4*60+30+15+6, i*60+30+35 );

/*
	   	g.setColor( Color.red );
            s[0] = String.valueOf(pre[i*2]).charAt(0);
            g.drawChars( s, 0, 1, 4*60+30+15+6, i*60+30+5 );
            s[0] = String.valueOf(pre[i*2+1]).charAt(0);
            g.drawChars( s, 0, 1, 4*60+30+15+6, i*60+30+35 );
	   	g.setColor( Color.black );
*/
        }
    }

	public void drawSwitch( Graphics g, Switch sw, int rx, int ry )
	{
        char[] s1 = new char[2];
        s1[1] = 0;
        char[] s2 = new char[2];
        s2[1] = 0;

	   	g.setColor( Color.black );
		g.draw3DRect( rx*60+15, ry*60+30, 30, 30, true );

//	   	g.setColor( Color.red );
        s1[0] = String.valueOf(sw.getI1()).charAt(0);
        s2[0] = String.valueOf(sw.getI2()).charAt(0);
//        g.drawChars( s1, 0, 1, rx*60+15-6, ry*60+30+5 );
//        g.drawChars( s2, 0, 1, rx*60+15-6, ry*60+30+25+10 );
		if( sw.isVisited() )
		if( sw.isExchanged() )
		{
//	        g.drawChars( s2, 0, 1, rx*60+15+30, ry*60+30+5 );
//	        g.drawChars( s1, 0, 1, rx*60+15+30, ry*60+30+25+10 );

			g.drawLine( rx*60+15, ry*60+30+5, rx*60+15+30, ry*60+30+25 );
			g.drawLine( rx*60+15, ry*60+30+25, rx*60+15+30, ry*60+30+5 );
		}
		else
		{
//	        g.drawChars( s1, 0, 1, rx*60+15+30, ry*60+30+5 );
//	        g.drawChars( s2, 0, 1, rx*60+15+30, ry*60+30+25+10 );

			g.drawLine( rx*60+15, ry*60+30+5, rx*60+15+30, ry*60+30+5 );
			g.drawLine( rx*60+15, ry*60+30+25, rx*60+15+30, ry*60+30+25 );
		}
	}

	public void olddrawConnect( Graphics g, Switch[][] sw, int rx, int ry )
	{
		int ry2;
		int ry3;
		Switch sw1;
        Switch sw2;
		Switch sw3;
        try
        {
		    sw1 = sw[ry][rx];
            if( sw1.getI1() == -1 || sw1.getI2() == -1 ) return;
	    	ry2 = bn.getSwitchNumber(rx+1,sw1.getI1());
    		if( ry2 == -1 ) return;
		    sw2 = sw[ry2][rx+1];
    		ry3 = bn.getSwitchNumber(rx+1,sw1.getI2());
	    	if( ry3 == -1 ) return;
		    sw3 = sw[ry3][rx+1];
        }
        catch( Exception e)
        {
            return;
        }

        // for looping
        if( !sw1.isVisited() ) return;

		if( !sw1.isExchanged() )
		{
        // for looping
        if( sw2.isVisited() )
			if( !sw2.isExchanged() )
            {
				g.drawLine( rx*60+15+30, ry*60+30+5, (rx+1)*60+15, sw1.getI1()==sw2.getI1()?ry2*60+30+5:ry2*60+30+25 );
            }
			else
            {
				g.drawLine( rx*60+15+30, ry*60+30+5, (rx+1)*60+15, sw1.getI1()==sw2.getI1()?ry2*60+30+5:ry2*60+30+25 );
            }

        if( sw3.isVisited() )
			if( !sw3.isExchanged() )
				g.drawLine( rx*60+15+30, ry*60+30+25, (rx+1)*60+15, sw1.getI2()==sw3.getI2()?ry3*60+30+25:ry3*60+30+5 );
			else
				g.drawLine( rx*60+15+30, ry*60+30+25, (rx+1)*60+15, sw1.getI2()==sw3.getI2()?ry3*60+30+25:ry3*60+30+5 ); //ry3*60+30+25 );

		}
		else
		{
        if( sw2.isVisited() )
			if( !sw2.isExchanged() )
				g.drawLine( rx*60+15+30, ry*60+30+25, (rx+1)*60+15, sw1.getI1()==sw2.getI1()?ry2*60+30+5:ry2*60+30+25 );
			else
				g.drawLine( rx*60+15+30, ry*60+30+25, (rx+1)*60+15, sw1.getI1()==sw2.getI1()?ry2*60+30+5:ry2*60+30+25 ); //ry2*60+30+5 );

        if( sw3.isVisited() )
			if( !sw3.isExchanged() )
				g.drawLine( rx*60+15+30, ry*60+30+5, (rx+1)*60+15, sw1.getI2()==sw3.getI2()?ry3*60+30+25:ry3*60+30+5 );// ry3*60+30+25 );
			else
				g.drawLine( rx*60+15+30, ry*60+30+5, (rx+1)*60+15, sw1.getI2()==sw3.getI2()?ry3*60+30+25:ry3*60+30+5 ); //ry3*60+30+5 );
		}
	}

	public void drawConnect( Graphics g, Switch[][] sw, int rx, int ry )
	{
		int ry2;
		int ry3;
        int c1,c2;
		Switch sw1;
        Switch sw2;
		Switch sw3;

	    sw1 = sw[ry][rx];

        // for looping
        // get parameters and draw the first switch I1 connect
        if( sw1.getI1() != -1 )
        {
	    	ry2 = bn.getSwitchNumber(rx+1,sw1.getI1());
            if( ry2 != -1 )
            {
    		    sw2 = sw[ry2][rx+1];
           		if( !sw1.isExchanged() )    c1 = 1;
                else    c1 = 2;

        if( !(!sw2.isVisited() && !sw1.isVisited()) )
                if( sw1.getI1() == sw2.getI1() || sw1.getI1() == sw2.getI2() )
                {
                    if( sw1.getI1() == sw2.getI1() )
                   		if( !sw2.isExchanged() )    c2 = 1;
                        else    c2 = 1;
                    else
                   		if( !sw2.isExchanged() )    c2 = 2;
                        else    c2 = 2;
                    this.drawSingleConnect( g, rx, ry, ry2, c1, c2 );
                }
            }
        }

        // get parameters and draw the first switch I2 connect
        if( sw1.getI2() != -1 )
        {
	    	ry3 = bn.getSwitchNumber(rx+1,sw1.getI2());
            if( ry3 != -1 )
            {
    		    sw3 = sw[ry3][rx+1];
           		if( !sw1.isExchanged() )    c1 = 2;
                else    c1 = 1;
        if( !(!sw3.isVisited() && !sw1.isVisited()) )
                if( sw1.getI2() == sw3.getI2() || sw1.getI2() == sw3.getI1() )
                {
                    if( sw1.getI2() == sw3.getI2() )
                   		if( !sw3.isExchanged() )    c2 = 2;
                        else    c2 = 2;
                    else
                   		if( !sw3.isExchanged() )    c2 = 1;
                        else    c2 = 1;
                    this.drawSingleConnect( g, rx, ry, ry3, c1, c2 );
                }
            }
        }

/*        try
        {
        }
        catch( Exception e)
        {
            return;
        }
*/
/*
		if( !sw1.isExchanged() )
		{
			if( !sw2.isExchanged() )
            {
				g.drawLine( rx*60+15+30, ry*60+30+5, (rx+1)*60+15, sw1.getI1()==sw2.getI1()?ry2*60+30+5:ry2*60+30+25 );
            }
			else
            {
				g.drawLine( rx*60+15+30, ry*60+30+5, (rx+1)*60+15, sw1.getI1()==sw2.getI1()?ry2*60+30+5:ry2*60+30+25 );
            }

			if( !sw3.isExchanged() )
				g.drawLine( rx*60+15+30, ry*60+30+25, (rx+1)*60+15, sw1.getI2()==sw3.getI2()?ry3*60+30+25:ry3*60+30+5 );
			else
				g.drawLine( rx*60+15+30, ry*60+30+25, (rx+1)*60+15, sw1.getI2()==sw3.getI2()?ry3*60+30+25:ry3*60+30+5 ); //ry3*60+30+25 );

		}
		else
		{
			if( !sw2.isExchanged() )
				g.drawLine( rx*60+15+30, ry*60+30+25, (rx+1)*60+15, sw1.getI1()==sw2.getI1()?ry2*60+30+5:ry2*60+30+25 );
			else
				g.drawLine( rx*60+15+30, ry*60+30+25, (rx+1)*60+15, sw1.getI1()==sw2.getI1()?ry2*60+30+5:ry2*60+30+25 ); //ry2*60+30+5 );

			if( !sw3.isExchanged() )
				g.drawLine( rx*60+15+30, ry*60+30+5, (rx+1)*60+15, sw1.getI2()==sw3.getI2()?ry3*60+30+25:ry3*60+30+5 );// ry3*60+30+25 );
			else
				g.drawLine( rx*60+15+30, ry*60+30+5, (rx+1)*60+15, sw1.getI2()==sw3.getI2()?ry3*60+30+25:ry3*60+30+5 ); //ry3*60+30+5 );
		}
*/
	}

	public void drawSingleConnect( Graphics g, int rx, int sn1, int sn2, int c1, int c2 )
	{
        g.drawLine( rx*60+15+30, sn1*60+30+(c1==1?5:25), (rx+1)*60+15, sn2*60+30+(c2==1?5:25) );
	}

}
